/******************************************************************************
 * Copyright (C) 2013 Nuvoton(SH) Technology Corp. All rights reserved.
 ******************************************************************************/

/***********2013/10/11 By WBChen**************/

#include "nano1xx.h"			  

void delay(void)
{
    uint32_t i;
    for (i=0; i<100000; i++);
}

void UART0_Init(uint32_t Baud)                 
{  
	GCR->PB_L_MFP = PB1_MFP_UART0_TX | PB0_MFP_UART0_RX ;
	CLK->APBCLK  |=  CLK_APBCLK_UART0_EN ;
	UART0->FUN_SEL = 0  ;                        //UART mode  
	UART0->TLCTL   = 0x3303 ;                    //8bit, 1-stop, no parity, Trigger Level:14   
	UART0->BAUD    = 12000000/Baud - 1 ;         //UATR_CLK has been selected 22M  	 
	UART0->CTL |= 0x00000200; 					 //enable Wake Up			
	UART0->IER     = UART_IER_RDA_IE ;           //enable receive IRQ
	NVIC_EnableIRQ(UART0_IRQn) ;  
}

void UART0_IRQHandler(void)
{     
	uint8_t Data, j;
	GPIOE->DOUT &= ~0x40 ; 
	if(UART0->ISR & UART_ISR_RDA_IS)
	{                        //receive IRQ    
		for(j=0;j<14;j++)
		{		
			Data = UART0->RBR;
			UART0->THR = Data;
			delay();
		}	  
	}
}

/////////////////////////////////////////////////////////////////////////////////////////
int32_t main(void)							   
{
	UNLOCKREG();
	CLK->CLKSEL0 =CLK->CLKSEL0&( ~CLK_CLKSEL0_HCLK_MASK)|CLK_CLKSEL0_HCLK_HIRC;	
	CLK->CLKSEL1 = CLK->CLKSEL1&(~CLK_CLKSEL1_UART_MASK)|CLK_CLKSEL1_UART_HIRC;
	LOCKREG();
	
	GPIOE->PMD    = GPIO_PMD_PMD6_OUTPUT ;
	UART0_Init(115200) ;
	UART0->THR=0x55;
	delay(); 
	
	
    while(1)
	{	
		GPIOE->DOUT |= 0x40 ;
		UNLOCKREG();
		CLK->PWRCTL |= (CLK_PWRCTL_PWRDOWN_EN );	   /* Set power down bit */
		SCB->SCR |= 0x04;						   /* Sleep Deep */
		LOCKREG();                                       		
		__wfi();
						
		UART0->CTL |= 0x00000200; 	   //enable Wake Up
		delay();		
	}
}
